<?PHP
	require_once('tshirt.php5');

	class Cart
	{
		protected $contents = array();
		private $items;

		public function __construct()
		{
			$this->items = 0;
			$this->contents = array();
		}

		public function __destruct()
		{
		}

		public function getCost()
		{
			foreach($this->contents as $tshirt)
				$i += $tshirt->getPrice() * $tshirt->getQuantity();
			return $i;
		}

		public function getItemCount()
		{
			return $this->items;
		}

		public function increaseOrder($shirt, $ammount = 1)
		{
			foreach($this->contents as &$cartItem)
			{
				if($cartItem->getID() == $shirt->getID())
				{
					$cartItem->increaseQuantity($ammount);
					break;
				}
				echo "should not see me<br>\n";
			}
		}

		public function getShirtCount()
		{
			foreach($this->contents as $tshirt)
				$i += $tshirt->getQuantity();
			return $i;
		}

		public function addToCart($tshirt)
		{
			// check if we allready have this shirt/size in our cart
			$exists = false;
			foreach($this->contents as $existingshirt)
				if($existingshirt->getID() == $tshirt->getID() && $existingshirt->getSize() == $tshirt->getSize())
					// Warn the user that an existing shirt with the same size allready exists in the cart
					return false;
			$this->contents[] = $tshirt;
			$this->items++;
			return true;
		}

		public function removeFromCart($item)
		{
			foreach($this->contents as $key => &$cartItem)
			{
				if($item == $key)
				{
					unset($this->contents[$key]);
					$this->items--;
				}
			}
		}

		public function isEmpty()
		{
			return ($this->items == 0);
		}

		public function mergeCarts($source)
		{
			foreach($source->contents as $oldShirt)
				$this->addToCart($oldShirt);
		}

		public function viewMiniCart()
		{
			echo "Du har ".$this->items." olika freml i din varukorg, totalt ".$this->getShirtCount()." T-shirts.";
			if(!$this->isEmpty() && $this->items < 5)
			{
				echo "<table border=0 cellpadding=0 cellspacing=0>\n<tr>\n";
				foreach($this->contents as $cartItem)
				{
					echo "<td>".$cartItem->getQuantity().$cartItem->getSize()." <img src=\"".$cartItem->getImage()."\" height=30></td>\n";
				}
				echo "</tr>\n</table>\n";
			}
		}

		public function viewContents()
		{
			$totalPrice = 0;
			$totalItems = 0;
			echo "<table width=100% border=0 cellpadding=0 cellspacing=0 vspace=20 hspace=20>\n";
			echo "<tr>\n<td>Bild:</td>\n<td>Namn:</td>\n<td>Storlek:</td>\n<td>Antal:</td>\n<td>Pris/st.</td>\n</tr>\n";
			foreach($this->contents as $key => $tshirt)
			{
				echo "<tr>\n<td><img src=\"".$tshirt->getImage()."\"></td>
<td>".$tshirt->getName()."</td>
<td><center>".$tshirt->getSize()."</center></td>
<td>".$tshirt->getQuantity()."</td>
<td>".$tshirt->getPrice()."</td>
<td><a href=\".?action=removeFromCart&item=$key\">Ta bort</a></td>
</tr>\n";
			}
			echo "<tr>\n<td colspan=5 height=1 bgcolor=\"#000000\"><tr>\n<td colspan=5>Totalt antal trjor: " . $this->getShirtCount() . "<br>\nTotalt pris:  " . $this->getCost() . "</td>\n</tr>\n";
			echo "</table>\n";
		}
	}
PHP?>
